local M = {}

local surfaces = {}
local Scale_1 = 1.0
local Scale_2 = 1.0
local Check_1 = 1.0
local Check_2 = 1.0

local function Rainbow_Mode(COLOR_1, COLOR_2, COLOR_3, Roughness)
	local objID = be:getPlayerVehicleID(0)
	local veh = be:getObjectByID(objID)
	local vd = extensions.core_vehicle_manager.getVehicleData(objID)
	vd.config.paints = vd.config.paints or {}
	local paint = createVehiclePaint({x = COLOR_1 / 1000, y = COLOR_2 / 1000, z = COLOR_3 / 1000, w=2}, {1, Roughness, 0, 0})

	vd.config.paints[1] = paint
	vd.config.paints[2] = paint
	vd.config.paints[3] = paint
	extensions.core_vehicle_manager.liveUpdateVehicleColors(objID, veh, 1, paint)
	extensions.core_vehicle_manager.liveUpdateVehicleColors(objID, veh, 2, paint)
	extensions.core_vehicle_manager.liveUpdateVehicleColors(objID, veh, 3, paint)
end

local function Drift_Drag_WTF_Mode(Mode)
	if Mode == 0 then Scale_1 = 1.0 Scale_2 = 1.0  Check_1 = 0.69999999   Check_2 = 0.69999997   end
	if Mode == 1 then Scale_1 = 0.5 Scale_2 = 0.5  Check_1 = 0.349999995  Check_2 = 0.349999993  end
	if Mode == 2 then Scale_1 = 2.0 Scale_2 = 3.5  Check_1 = 2.450000048  Check_2 = 2.450000046  end
	if Mode == 3 then Scale_1 = 0.9 Scale_2 = -0.5 Check_1 = -0.349999993 Check_2 = -0.349999995 end
	local number = number or 1

	local all_s = {
		"ASPHALT", "ASPHALT_OLD", "ASPHALT_PREPPED", "ASPHALT_WET", "ASPHALT_WET2", "ASPHALT_WET3", "CONCRETE", "CONCRETE2", "GRID", "GROUNDMODEL_ASPHALT1",
		"GROUNDMODEL_ASPHALT_OLD", "SLIPPERY", "BEACHSAND", "COBBLESTONE", "DERBY_DIRT", "DIRT", "DIRT_DUSTY", "DIRT_DUSTY_LOOSE", "DIRT_GRASS", "DIRT_LOOSE",
		"DIRT_LOOSE_DUSTY", "DIRT_ROCKY", "DIRT_ROCKY_LARGE", "DIRT_SANDY", "FOREST", "FOREST_FLOOR", "FRICTIONLESS", "GRASS", "GRASS2", "GRASS3",
		"GRASS4", "GRAVEL", "GRAVEL_WET", "GRAVEL_WET, GRAVEL_RIVERBED", "GROUNDMODEL_WOOD1", "GROUNDMODEL_WOOD2", "ICE", "KICKPLATE", "LEAVES_STRONG", "LEAVES_THIN",
		"METAL", "METAL_TREAD", "MUD", "PLASTIC", "ROCK", "ROCKS_LARGE", "ROCKYDIRT", "ROCK_CLIFF", "RUMBLE_STRIP", "SAND",
		"SANDTRAP", "SHOCK_ABSORBER", "SNOW", "SOFT_COLLISION_GENERAL", "VOID", "WOOD"} --56
	local all_default_value_1 = {
		0.98, 0.96, 1.50, 0.92, 0.92, 0.92, 0.98, 0.98, 0.98, 0.98,
		0.96, 0.60, 0.60, 0.95, 0.68, 0.68, 0.68, 0.65, 0.68, 0.68,
		0.65, 0.68, 0.68, 0.65, 0.61, 0.61, 0.00, 0.61, 0.61, 0.61,
		0.61, 0.68, 0.62, 0.62, 0.95, 0.95, 0.40, 2.00, 0.00, 0.00,
		0.85, 1.00, 0.55, 0.80, 0.93, 0.93, 0.68, 0.93, 0.96, 0.60,
		0.60, 0.00, 0.65, 0.00, 0.00, 0.95}
	local all_default_value_2 = {
		0.70, 0.67, 1.20, 0.55, 0.55, 0.55, 0.70, 0.70, 0.70, 0.70,
		0.67, 0.20, 0.60, 0.65, 0.76, 0.76, 0.78, 0.65, 0.76, 0.76,
		0.65, 0.78, 0.78, 0.65, 0.65, 0.65, 0.00, 0.65, 0.65, 0.65,
		0.65, 0.76, 0.60, 0.60, 0.70, 0.70, 0.20, 2.00, 0.00, 0.00,
		0.65, 0.68, 0.55, 0.70, 0.62, 0.62, 0.78, 0.62, 0.67, 0.60,
		0.60, 0.00, 0.40, 0.00, 0.00, 0.70}

	if be:getGroundModel(all_s[1]).data["slidingFrictionCoefficient"] < Check_1 and be:getGroundModel(all_s[1]).data["slidingFrictionCoefficient"] > Check_2 then else
		local function Сhanging_all_surfaces (number_2)
			if number_2 > 56 then number = 1 return else
				surfaces[all_s[number_2]] = be:getGroundModel(all_s[number_2]).data 
				surfaces[all_s[number_2]]["staticFrictionCoefficient" ] = all_default_value_1[number_2]*Scale_1 
				surfaces[all_s[number_2]]["slidingFrictionCoefficient"] = all_default_value_2[number_2]*Scale_2 
				be:setGroundModel(all_s[number_2], surfaces[all_s[number_2]])
				number = number + 1
				Сhanging_all_surfaces(number)
			end
		end
		Сhanging_all_surfaces(number)
	end
end

local function reload()
	reloadUI()
	be:reloadVehicle(0)
end

M.Rainbow_Mode = Rainbow_Mode
M.Drift_Drag_WTF_Mode = Drift_Drag_WTF_Mode
M.reload = reload
return M
